package ru.dbotthepony.mc.otm.client.screen.panels.slot

import net.minecraft.world.item.ItemStack
import ru.dbotthepony.kommons.util.Delegate
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen
import ru.dbotthepony.mc.otm.client.screen.panels.EditablePanel
import ru.dbotthepony.mc.otm.container.ItemFilter

open class FilterSlotPanel<out S : MatteryScreen<*>>(
	screen: S,
	parent: EditablePanel<*>?,
	val slot: Delegate<ItemFilter>,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = SIZE,
	height: Float = SIZE
) : AbstractSlotPanel<S>(screen, parent, x, y, width, height) {
	private var lastFilteredItemDisplayUpdate = System.nanoTime()
	private var filteredItemDisplayIndex = 0

	override val itemStack: ItemStack get() {
		val items = slot.get().displayItems

		if (items.isEmpty())
			return ItemStack.EMPTY

		if (System.nanoTime() - lastFilteredItemDisplayUpdate >= 1_000_000_000L || filteredItemDisplayIndex !in items.indices) {
			lastFilteredItemDisplayUpdate = System.nanoTime()
			filteredItemDisplayIndex = random.nextInt(items.size)
		}

		return items.asList()[filteredItemDisplayIndex].asItemStack()
	}

	override fun mouseClickedInner(x: Double, y: Double, button: Int): Boolean {
		slot.accept(ItemFilter.item(screen.menu.carried))
		return true
	}
}
