package ru.dbotthepony.mc.otm.menu.input

import net.minecraft.world.entity.player.Player
import ru.dbotthepony.kommons.util.Delegate
import ru.dbotthepony.mc.otm.container.ItemFilter
import ru.dbotthepony.mc.otm.container.ItemFilterSet
import ru.dbotthepony.mc.otm.core.immutableList
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import ru.dbotthepony.mc.otm.network.StreamCodecs
import java.util.function.Predicate

class ItemFilterInput(menu: MatteryMenu, maxSlots: Int, var filter: Delegate<ItemFilterSet>?, var allowRecursive: Boolean = false) {
	val synchers = immutableList(maxSlots) { i ->
		menu.mSynchronizer.computed({ filter?.get()?.get(i) ?: ItemFilter.EMPTY }, StreamCodecs.ITEM_FILTER)
	}

	val inputs = immutableList(maxSlots) { i ->
		menu.PlayerInput(StreamCodecs.ITEM_FILTER, handler = {
			if (allowRecursive || it.depth <= 1) {
				val filter = filter ?: return@PlayerInput

				if (it.hasRules)
					filter.accept(filter.get().addOrReplace(i, it))
				else
					filter.accept(filter.get().removeAt(i))
			}
		})
	}

	val slots = immutableList(maxSlots) { i ->
		Delegate.Of(synchers[i], inputs[i])
	}

	val isWhitelist = BooleanInputWithFeedback.dispatch(
		menu,
		Delegate.Of({ filter?.get() ?: ItemFilterSet.EMPTY }, { filter?.accept(it) }),
		{ it.isWhitelist },
		{ it, v -> it.isWhitelist(v) }
	)

	fun filter(predicate: Predicate<Player>) {
		inputs.forEach { it.filter(predicate) }
		isWhitelist.input.filter(predicate)
	}
}
