package ru.dbotthepony.mc.otm.player

import net.minecraft.server.level.ServerPlayer
import net.minecraft.world.item.Item
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.container.EnhancedContainer
import ru.dbotthepony.mc.otm.container.IContainerSlot
import ru.dbotthepony.mc.otm.container.IEnhancedContainer
import ru.dbotthepony.mc.otm.container.ItemFilter
import ru.dbotthepony.mc.otm.triggers.MatteryInventoryChangeTrigger

class ExopackContainer(size: Int, val player: MatteryPlayer) : EnhancedContainer<IPlayerInventorySlot>(size) {
	private inner class Slot(slot: Int) : IContainerSlot.Simple(slot, this@ExopackContainer), IPlayerInventorySlot {
		override var shouldCharge: Boolean
			get() = (PlayerInventoryWrapper.SLOTS + slot) in player.slotsChargeFlag
			set(value) { if (value) player.slotsChargeFlag.add(PlayerInventoryWrapper.SLOTS + slot) else player.slotsChargeFlag.remove(PlayerInventoryWrapper.SLOTS + slot) }

		override var filter: ItemFilter
			get() = player.slotFilters[PlayerInventoryWrapper.SLOTS + slot] ?: ItemFilter.EMPTY
			set(value) { if (value.allowAll) player.slotFilters.remove(PlayerInventoryWrapper.SLOTS + slot) else player.slotFilters[PlayerInventoryWrapper.SLOTS + slot] = value }
	}

	override fun notifySlotChanged(slot: Int, old: ItemStack) {
		super.notifySlotChanged(slot, old)

		if (player.ply is ServerPlayer)
			MatteryInventoryChangeTrigger.trigger(player.ply, this, this[slot])
	}

	override fun containerSlot(slot: Int): IPlayerInventorySlot {
		return Slot(slot)
	}

	override val hasFilterableSlots: Boolean
		get() = true
}
