package ru.dbotthepony.mc.otm.worldgen

import net.minecraft.core.BlockPos
import net.minecraft.core.Holder
import net.minecraft.world.level.levelgen.feature.ConfiguredFeature
import net.minecraft.world.level.levelgen.placement.PlacementModifier
import ru.dbotthepony.mc.otm.core.collect.Vec3iHashStrategy
import ru.dbotthepony.mc.otm.worldgen.feature.EnhancedFeature
import ru.dbotthepony.mc.otm.worldgen.placement.EnhancedPlacement

fun PlacementModifier.wrap(): EnhancedPlacement {
	return EnhancedPlacement.Wrapper(this)
}

data class PlacementPos(val pos: BlockPos, val variables: PlacementVariableMap) : Comparable<PlacementPos> {
	override fun compareTo(other: PlacementPos): Int {
		return Vec3iHashStrategy.compare(pos, other.pos)
	}
}

@JvmName("placement")
fun Holder<EnhancedFeature.Configured<*, *>>.placement() = EnhancedFeature.ConfiguredWrapper(this)
@JvmName("vanillaPlacement")
fun Holder<ConfiguredFeature<*, *>>.placement() = EnhancedFeature.Wrapper.configure(this)
fun ConfiguredFeature<*, *>.placement() = EnhancedFeature.Wrapper.configure(this)
